// Test the abs algorithm on the std::complex type

#include <glas/algorithm/abs.hpp>
#include <boost/rational.hpp>

namespace glas {
template <class T>
struct abs_functor< boost::rational<T> > {
  typedef boost::rational<T> argument_type ;
  typedef boost::rational<T> result_type ;
  inline result_type operator() ( argument_type const& v ) const 
  { return boost::abs( v ) ; }
};
} // namespace glas

int main()
{
  boost::rational<int> a(3,-5) ;
  boost::rational<int> abs_a = glas::abs( a ) ;
  double d_abs_a = boost::rational_cast<double>(abs_a) ;
  if (d_abs_a > 0.599999 && d_abs_a < 6.000001 ) return 0 ;
  else return 1 ;
}

